#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
-------------------------------------------------------------------------------
Function:
【总结】Python中常见字符编码和解码方面的错误及其解决办法
http://www.crifan.com/summary_python_2_x_common_string_encode_decode_error_reason_and_solution

Author:     Crifan
Verison:    2012-11-29
-------------------------------------------------------------------------------
"""
 
#任何字符，都可以在：
#http://unicodelookup.com/
#中，查找到对应的unicode的值

def python2xPrintUnicodeOmitSpecial():
    #http://zhidao.baidu.com/question/500133781.html
    slashUStr = "\\u3232\\u6674"; #(有) 晴
    decodedUniChars = slashUStr.decode("unicode-escape"); #此处已经可以正常获得对应的两个Unicode字符了
    unicodeButContainSpecialChar = decodedUniChars;
    #print "unicodeButContainSpecialChar=",unicodeButContainSpecialChar;
    
    #此处在GBK编码的cmd中输出的话，会出现错误的：
    #UnicodeEncodeError: 'gbk' codec can't encode character u'\u3232' in position 0: illegal multibyte sequence
    #那是因为，Unicode字符：0x3232，是个特殊字符，而此字符，在GBK编码字符集中，本身就不包含此特殊字符，所以当然没法把这个特殊字符编码为对应的GBK字符，所以出错，更无法显示
    
    #如果只是想要：
    #显示那些正常可以显示的字符，忽略个别特殊不能显示的字符
    #那么可以改为如下代码：
    encodedShowableGbk = unicodeButContainSpecialChar.encode("GBK", "ignore");
    print "encodedShowableGbk=",encodedShowableGbk; #encodedShowableGbk= 晴

###############################################################################
if __name__=="__main__":
    python2xPrintUnicodeOmitSpecial();